
package scatterplot;

import java.util.Vector;

public class Transform
{

    static double[][] V2Dtoa2d(Vector vector, int i, int j)
    {
        Vector avector[] = new Vector[i];
        vector.copyInto(avector);
        double ad[][] = new double[i][j];
        for(int k = 0; k < i; k++)
        {
            Double adouble[] = new Double[j];
            avector[k].copyInto(adouble);
            for(int l = 0; l < j; l++)
                ad[k][l] = adouble[l].doubleValue();

        }

        return ad;
    }

    static int[][] a2dtoa2ipixel(double ad[][], int i, int j, int k)
    {
        double ad1[] = new double[j];
        int ai[][] = new int[i][j];
        for(int l = 0; l < i; l++)
        {
            for(int i1 = 0; i1 < j; i1++)
                ad1[i1] = ad[l][i1];

            double d = Stat.max(ad1);
            double d1 = Stat.min(ad1);
            double d2 = d - d1;
            for(int j1 = 0; j1 < j; j1++)
            {
                double d3 = ((ad[l][j1] - d1) / d2) * (double)(k - 10);
                ai[l][j1] = (int)Math.round(d3);
            }

        }

        return ai;
    }

    static double[][] a2dtoa2d3D(double ad[][], int i, int j)
    {
        double ad1[] = new double[j];
        double ad2[][] = new double[i][j];
        for(int k = 0; k < i; k++)
        {
            for(int l = 0; l < j; l++)
                ad1[l] = ad[k][l];

            double d = Stat.max(ad1);
            double d1 = Stat.min(ad1);
            double d2 = d - d1;
            for(int i1 = 0; i1 < j; i1++)
                ad2[k][i1] = (ad[k][i1] - d1) / (d2 / 2D) - 1.0D;

        }

        return ad2;
    }

    static int[] adtoaipixel(double ad[], int i, int j)
    {
        int ai[] = new int[i];
        double d = Stat.max(ad);
        double d1 = Stat.min(ad);
        double d2 = d - d1;
        for(int k = 0; k < i; k++)
            ai[k] = (int)Math.round(((ad[k] - d1) / d2) * (double)(j - 10));

        return ai;
    }

    static double[] VDtoad(Vector vector, int i)
    {
        Double adouble[] = new Double[i];
        vector.copyInto(adouble);
        double ad[] = new double[i];
        for(int j = 0; j < i; j++)
            ad[j] = adouble[j].doubleValue();

        return ad;
    }

    static double[] aitoad(int ai[], int i)
    {
        double ad[] = new double[i];
        for(int j = 0; j < i; j++)
            ad[j] = ai[j];

        return ad;
    }

    static int[] getMarked(boolean aflag[])
    {
        Vector vector = new Vector();
        for(int i = 0; i < aflag.length; i++)
            if(aflag[i])
                vector.addElement(new Integer(i));

        Integer ainteger[] = new Integer[vector.size()];
        int ai[] = new int[vector.size()];
        vector.copyInto(ainteger);
        for(int j = 0; j < vector.size(); j++)
            ai[j] = ainteger[j].intValue();

        return ai;
    }

    static int[] getUnMarked(boolean aflag[])
    {
        Vector vector = new Vector();
        for(int i = 0; i < aflag.length; i++)
            if(!aflag[i])
                vector.addElement(new Integer(i));

        Integer ainteger[] = new Integer[vector.size()];
        int ai[] = new int[vector.size()];
        vector.copyInto(ainteger);
        for(int j = 0; j < vector.size(); j++)
            ai[j] = ainteger[j].intValue();

        return ai;
    }

    public Transform()
    {
    }
}
