
package snap;

import java.util.EventObject;
import java.util.Vector;

/** An event that indicates that some action has occured on a specific set
  * of keys (tuples).  This event will be thrown from Snapable visualizations
  * and will be passed along to the visualization through the performSnapEvent()
  * method.
  *
  * @author Nathan Conklin - nathan@conklinfamily.net
  * @author Chris North - north@cs.vt.edu
  * @author Varun Saini - vsaini@vt.edu
  * @author Umer Farooq - ufarooq@vt.edu
  */
public class SnapEvent extends EventObject
{

protected String eventType;
protected Vector keys;

public SnapEvent(Object source, String eventType, Vector keys)
{
    super(source);
    this.keys = keys;
    this.eventType = eventType;
}

/** The action that occured at the source */
public String getEventType()
{
    return eventType;
}

/** The primary keys that identify the tuple(s) in the SnapEvent.  The type of
  * the primary keys is determined by the database. */
public Vector getKeys()
{
    return keys;
}


}

