
package snap.adapter;

import snap.*;
import snap.database.Query;

import java.rmi.*;
import java.util.*;
import java.sql.*;
import java.net.URL;
import javax.swing.*;

/** Adapter between Snap's general interface to the interface specific
  * for Cave visualizations.
  */
public class CaveAtomAdapter extends TechnologyAdapter //implements SnapEventListener
{
//	private Thread t;
	private Snap snap;
	private Snapable visualization;
	private SnapEventListener sel;

/* Set when firing an event at a visualization.  When set, the adapter
ignores events coming back from the visualization.  Allows the adapter to
ignore talkback. */
private boolean ignoreVisualizationEvents;

private final int HANDLE_LOAD = 0;
private final int HANDLE_PERFORMSNAPEVENT = 1;
private final int HANDLE_SNAPEVENTOCCURED = 2;

private final String LOAD_ACTION = "Load";

private Vector loadQueue = new Vector();
private Vector snapEventOccuredQueue = new Vector();
private Vector performSnapEventQueue = new Vector();
private Vector eventSelectionQueue = new Vector();

// In JDBC, each thread should have its own connection
	private Connection connection = null;
//protected Snap snap;

public CaveAtomAdapter(Snap snap)
	{
//   	this.visualization = visualization;
	this.snap = snap;
//	visualization.addSnapEventListener(this);
	}

/** Called when Snap needs to load data into the visualization */
public void load(Query query)
	{
	}

/** Called when Snap needs to unload data from the visualization */
public void unload(Query query)
	{
	}

/** Called when Snap needs to fire an event at the visualization */
public void performSnapEvent(SnapEvent e)
	{
	snap.getFeedbackPanel().setText("atom " + e.getKeys().get(0));
	Rmi Test = new Rmi();
	for (int i=0; i< e.getKeys().size(); i++)
	{
		Test.SendMessage("atom", (String)e.getKeys().get(i));
	}

	/*
	if (System.getSecurityManager() == null)
	{
		System.setSecurityManager(new RMISecurityManager());
	}
	try
	{

	snap.getFeedbackPanel().setText("Starting rmi");
	Hello obj = null;
	obj = (Hello)Naming.lookup("//anray2.campus.vt.edu/HelloServer");
	snap.getFeedbackPanel().setText("Look up worked :)");
	String message = obj.sayHello(Selected);
	snap.getFeedbackPanel().setText("RMI worked  " + message + " " + Test);
	 snap.getFeedbackPanel().setText("Atom " + e.getKeys().get(0));
	 Rmi Test = new Rmi();
	 Test.SendMessage("bond", (String)e.getKeys().get(0));
	// test event fields for an appropriate id
	}
	 */

	}

/** Returns a list of Actions supported by a visualization */
public Enumeration getSupportedActions()
	{
	Vector v = new Vector();
	v.add("Select (receive only)");
//	v.add("Unload");
//	v.add("Load");
	// do more v.add()
	return v.elements();
	}

/** Returns the component's Icon or tries to find a default Icon */
public Icon getIcon()
	{
	Icon icon = null;
	try
	{
		// Must change
		String base = snap.getCodeBase().toString();
		String iconURL = base + "snap/hotjava.icon.gif";
		//String iconURL = base + "snap/2.icon.gif";
		icon = 	new ImageIcon(new URL(iconURL));
	}
	catch(Exception e)
	{
		snap.getFeedbackPanel().setText("Could not load icon caveatom.gif :(");
		System.err.println("CaveTechnologyAdapter " +
			"unable to create an icon: " + e.toString());
	}
	return icon;
	}

}
