
package snap.adapter;



import snap.*;
import snap.database.Query;

import java.util.*;
import java.sql.*;
import java.net.URL;
import javax.swing.*;
import java.rmi.*;
/*
import java.rmi.Naming;
import java.rmi.RemoteException;
import java.applet.Applet;
*/
/** Adapter between Snap's general interface to the interface specific
  * for Cave visualizations.
  */
public class CaveTechnologyAdapter extends TechnologyAdapter
{

protected Snap snap;

public CaveTechnologyAdapter(Snap snap)
{
	this.snap = snap;
}

/** Called when Snap needs to load data into the visualization */
public void load(Query query)
{
}

/** Called when Snap needs to fire an event at the visualization */
public void performSnapEvent(SnapEvent e)
{
	String Test = "";
	Vector V = e.getKeys();
	String Selected = "";
	for (int i=0; i< V.size(); i++)
	{
		Test = Test + V.get(i) + "  ";
		Selected = "" + V.get(i);
	}
	/*Add RMI CODE HERE*/
	if (System.getSecurityManager() == null) 
	{
	            System.setSecurityManager(new RMISecurityManager());
	}
	try 
	{
		Hello obj = null;
		snap.getFeedbackPanel().setText("Starting rmi");
		obj = (Hello)Naming.lookup("//anray2.campus.vt.edu/HelloServer");
		snap.getFeedbackPanel().setText("Look up worked :)");
		String message = obj.sayHello(Selected);
		snap.getFeedbackPanel().setText("RMI worked  " + message + " " + Test);
		Test = Test + "Beginning RMI ";
		String ComputerName="anray2.campus.vt.edu";
		String name = "//" + ComputerName + "/Compute";
	//	String name = "//" + getCodeBase().getHost() + "/Compute";
		Compute comp = (Compute) Naming.lookup(name);


		Test = Test + "  " + "Lookup worked";
		Message Temp = new Message("Hello World");
		String ReturnValue = (String)(comp.executeTask(Temp));
		Test = Test + " " + "Executing task worked";
		//System.out.println("The return value is " + ReturnValue);
		//snap.getFeedbackPanel().setText(e.getEventType()+"    "+ Test + " " + ReturnValue);
		snap.getFeedbackPanel().setText("RMI worked  " + ReturnValue);
	} 
	catch (Exception extra) 
	{
		snap.getFeedbackPanel().setText("The rmi call did not work again :( "+ extra.getMessage() + " " + Test); 
	//	System.err.println("It does not work : ( : " + extra.getMessage());
	//	extra.printStackTrace();
	}
}

/** Returns a list of Actions supported by a visualization */
public Enumeration getSupportedActions()
{
	Vector v = new Vector();
	v.add("Select (receive only)");
	// do more v.add()
	return v.elements();
}

/** Returns the component's Icon or tries to find a default Icon */
public Icon getIcon()
{
	Icon icon = null;
	try
	{
		// Must change
		String base = snap.getCodeBase().toString();
		String iconURL = base + "snap/hotjava.icon.gif";
		icon = 	new ImageIcon(new URL(iconURL));
	}
	catch(Exception e)
	{
		System.err.println("CaveTechnologyAdapter " + 
			"unable to create an icon: " + e.toString());
	}
	return icon;
}

}
