
package snap.graph;

/** Part of a connection between two visualizations; a NodeActionPair 
  * contains a Node and the Action to be fired on that node.
  *
  * @author Varun Saini - vsaini@vt.edu 
  * @author Chris North - north@cs.vt.edu
  * @author Nathan Conklin - nathan@conklinfamily.net
  * @author Umer Farooq - ufarooq@vt.edu
  * @author Aniket Prabhune - aprabhun@vt.edu
  */
public class NodeActionPair
{

Node node;
String action;

public NodeActionPair(Node node, String action)
{
    setNode(node);
    setAction(action);
}

public void setAction(String action)
{
    this.action = action;
}

public String getAction()
{
    return action;
}

public void setNode(Node node)
{
    this.node = node;
}

public Node getNode()
{
    return node;
}

}

