
package snap.ui;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/** A modal message box.
  *
  * @author Nathan Conklin - nathan@conklinfamily.net
  * @author Chris North - north@cs.vt.edu
  */
public class MsgBox extends JDialog
implements ActionListener
{
	boolean id = false;
	JButton ok,can;

public MsgBox(String title, String msg, boolean okcan)
{
	super(new JFrame(), title, true);
	getContentPane().setLayout(new BorderLayout());

	JTextArea textArea = new JTextArea(msg);
	textArea.setLineWrap(true);
	textArea.setWrapStyleWord(true);
	textArea.setPreferredSize(new Dimension(400, 100));
	textArea.setEditable(false);
	JScrollPane scrollPane = new JScrollPane(textArea);

	getContentPane().add("Center", scrollPane);
	addOKCancelPanel(okcan);
	pack();
	setPositionCentered(this);
	setVisible(true);
}

private void addOKCancelPanel( boolean okcan )
{
	JPanel p = new JPanel();
	p.setLayout(new FlowLayout());
	createOKButton( p );
	if (okcan == true)
		createCancelButton( p );
	getContentPane().add("South",p);
}

private void createOKButton(JPanel p)
{
	p.add(ok = new JButton("OK"));
	ok.addActionListener(this); 
}

private void createCancelButton(JPanel p)
{
	p.add(can = new JButton("Cancel"));
	can.addActionListener(this);
}


/** Centers the frame */
private void setPositionCentered(Window window)
{
	int x = (window.getGraphicsConfiguration().getBounds().width / 2) -
		(window.getWidth() / 2);
	int y = (window.getGraphicsConfiguration().getBounds().height / 2) -
		(window.getHeight() / 2);
	window.setLocation(x, y);
}

public void actionPerformed(ActionEvent ae)
{
	if(ae.getSource() == ok)
	{
		id = true;
		setVisible(false);
	}
	else if(ae.getSource() == can)
		setVisible(false);
}


}
