package snap.ui.diagram;

import snap.*;
import snap.database.*;

import javax.swing.*;
import java.sql.*;
import java.awt.*;

/** Component used in loading the visualization schema.
  *
  * @author Nathan Conklin - nathan@conklinfamily.net
  * @author Matt Clement - macleme2@vt.edu
  * @author Chris North - north@cs.vt.edu
  */
public class VisualizationSchema extends JPanel
{

public VisualizationSchema(Snap snap)
{
    this.setLayout(new BorderLayout());
	Connection dataConnection = snap.getDatabaseManager().getConnection();

	if(dataConnection != null)
	{
		// Here we now know that the databases are ready for use
		DiagramPanel connectionsPanel = new DiagramPanel(snap);
		snap.getGraph().addGraphChangeEventListener(connectionsPanel);
		JScrollPane connectionsPane = new JScrollPane(connectionsPanel);
		this.add(connectionsPane, BorderLayout.CENTER);
	}
	else
	{
		System.err.println("VisualizationSchema: Databases are not ready.");
		// Databases are not ready.  User must connect to data source
	}
}

};
